/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
   Modulo para utilizar o Serv. MTA SCEO com Mysql                     
   Programado por Lucas Priori                                         
   Versao: 1.2.6                                                       
                                                                       
   Compilar no Linux                                                   
   [32 BITS]                                                           
   gcc sceo_mysql.c -o sceo_mysql -lmysqlclient -lcrypt                
   [64 BITS]                                                           
   gcc sceo_mysql.c -o sceo_mysql -DA64 -lmysqlclient -lcrypt          
                                                                       
   Compilar no FreeBSD                                                 
   [32 BITS]                                                           
   gcc sceo_mysql.c -o sceo_mysql -DFreeBSD -L/usr/local/lib/mysql -lmysqlclient -lcrypt
   [64 BITS]                                                           
   gcc sceo_mysql.c -o sceo_mysql -DA64 -DFreeBSD -L/usr/local/lib/mysql -lmysqlclient -lcrypt
                                                                       
  ******************************************************************   
  sceo_mysql e' um modulo externo que da suporte a consultas Mysql     
  para o servidor MTA Sceo                                             
  Copyright (C) 2007, 2008, 2009  Lucas Priori                         
                                                                       
  This program is free software: you can redistribute it and/or modify 
  it under the terms of the GNU General Public License as published by 
  the Free Software Foundation, either version 3 of the License, or    
  (at your option) any later version.                                  
                                                                       
  This program is distributed in the hope that it will be useful,      
  but WITHOUT ANY WARRANTY; without even the implied warranty of       
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        
  GNU General Public License for more details.                         
                                                                       
  You should have received a copy of the GNU General Public License    
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/
#include<stdio.h>
#include<stdlib.h>
#include<fcntl.h>
#include<string.h>
#include<sched.h>
#include<unistd.h>
#include<sys/stat.h>
#ifdef FreeBSD
 #include<rpcsvc/crypt.h>
 #include "/usr/local/include/mysql/mysql.h"
 #include "/usr/local/include/mysql/errmsg.h"
#else
 #include<crypt.h>
 #include<mysql/mysql.h>
 #include<mysql/errmsg.h>
#endif


//-----
#define TAM_buffer 2048
#define VERSAO "1.2.6"
#define TAM_cmd 300
#define TAM_cmd_sql 600
#define ALIAS_LIMIT 10
#define MAILDIRSIZE 1
#define MAILBOX 2
#define MAX_ptr_quota 5


//---------------------------------------------------
//      Variaveis GLOBAIS                            
//---------------------------------------------------
MYSQL *mysql = NULL;
MYSQL *mysqlt = NULL;
MYSQL_RES *myres; 
MYSQL_ROW myreg;
/* --- DADOS DE CONEXAO --- */
char host[100]={0};
char db[100]={0};
char user[100]={0};
char pass[100]={0};
char user_table[100]={0};
char user_login_field[100]={0};
char user_pass_field[100]={0};
char user_home_field[100]={0};
char user_maildir_field[100]={0};
char user_quota_field[100]={0};
char user_dlocal_field[100]={0};
char user_pass_type[50]={0};
char domain_table[100]={0};
char domain_field[100]={0};
char alias_table[100]={0};
char alias_field[100]={0};
char alias_rcpt_field[100]={0};
char adomain_table[100]={0};
char adomain_field[100]={0};
char adomain_domain_field[100]={0};
char adomain_alias_seek=0;
char where_clause[100]={0};
char user_pass_query[500]={0};
char reset_pass=0;
//----
char cmd[TAM_cmd+1];
char buffer[TAM_buffer+1];
char linha[TAM_buffer+1];
char cmd_sql[TAM_cmd_sql+1];
char maildirsize=1;
char quota_type=MAILDIRSIZE;
char *ptr=cmd;
unsigned int tam_user=0;

//---------------------------------------------------
//Funcao para comparar duas strings desconciderando  
//a diferena entre maiusculas e minusculas          
//Retornos:                                          
//0 = strings so iguais                             
//1 = strings so diferentes                         
int cmp_str(char *string1,char *string2,int num_bytes){
 if(!num_bytes){
  if(*string1==*string2)return 0;
  return 1;
 }
 int ret_val=0;
 
 #ifdef A64
  asm(
   "mov  %0,%%rdi           \n"
   "mov  %1,%%rsi           \n"
  "CMP_STR_proxbyte:        \n"
   "movb (%%rsi),%%al       \n"
   "cmpb (%%rdi),%%al       \n"
   "jne  CMP_STR_trocar     \n"
  "CMP_STR_incr:            \n"
   "inc  %%rsi              \n"
   "inc  %%rdi              \n"
   "loop CMP_STR_proxbyte   \n"
   "jmp  CMP_STR_term       \n"
  "CMP_STR_trocar:          \n"
   "xorb $32,%%al           \n"
   "cmpb (%%rdi),%%al       \n"
   "je   CMP_STR_incr       \n"
  "CMP_STR_term:            \n"
   "testw %%cx,%%cx         \n"
   "jz   CMP_STR_fim        \n"
   "movw $1,%%cx            \n"
  "CMP_STR_fim:             \n"
   "movw  %%cx,%3           \n"
   :
   :"m"(string1),"m"(string2),"c"(num_bytes),"m"(ret_val)
   :"rdi","rsi","rax"
  );
 #else
  asm(
   "mov  %0,%%edi           \n"
   "mov  %1,%%esi           \n"
  "CMP_STR_proxbyte:        \n"
   "mov  (%%esi),%%al       \n"
   "cmp  (%%edi),%%al       \n"
   "jne  CMP_STR_trocar     \n"
  "CMP_STR_incr:            \n"
   "inc  %%esi              \n"
   "inc  %%edi              \n"
   "loop CMP_STR_proxbyte   \n"
   "jmp  CMP_STR_term       \n"
  "CMP_STR_trocar:          \n"
   "xor  $32,%%al           \n"
   "cmp  (%%edi),%%al       \n"
   "je   CMP_STR_incr       \n"
  "CMP_STR_term:            \n"
   "test  %%cx,%%cx         \n"
   "jz   CMP_STR_fim        \n"
   "mov  $1,%%cx            \n"
  "CMP_STR_fim:             \n"
   "mov   %%cx,%3           \n"
   :
   :"m"(string1),"m"(string2),"c"(num_bytes),"m"(ret_val)
   :"edi","esi","eax"
  );
 #endif
 return ret_val;
}


//---------------------------------------------------
// Copia uma string analisando com variaveis         
void cp_str_var(char *destino, char *origem){
 
 while(*origem){
  if(*origem == '%'){
   if(*++origem == 'u'){
    strcpy(destino, ptr);  // Usuario
    destino+=tam_user;
   }else {
    *destino++=*origem;
    if(!*origem)return;
   }
   origem++;
  }else *destino++=*origem++;
 }
 *destino=*origem;
}

//---------------------------------------------------
//Retorna o tamanho atual da caixa postal de um      
//usuario                                            
void ret_quota(char *home,char *maildir,long long int *tam_cxp,long long int *num_msgs){
 char linha_quota[100]={0};
 char prim_linha=1;
 int arq_maildir;
 unsigned int b_lidos=0;
 unsigned int cont1=0;
 unsigned int cont2=0;
 unsigned int cont3=0;
 int temp=0;
 long long int tam=0;
 long long int num=0;
 long long int ttotal=0;
 long long int ntotal=0;
 
 
 if(!home || !maildir)return;   // Impossivel medir o tamanho sem saber o caminho
 snprintf(linha,sizeof(linha),"%s/%s",home,maildir);
 /* Metodo via maildirsize */
 switch(quota_type){
 case MAILDIRSIZE:
  strcat(linha,"/maildirsize\0");
  arq_maildir=open(linha,O_RDWR | O_CREAT,0666);
  if(arq_maildir<0)return;      // Arquivo maildirsize nao existe
  // Travando o arquivo
  while(lockf(arq_maildir,F_TLOCK,0)&& cont3<100){
   cont3++;
   sched_yield();        // Passar a vez para outro processo. Aguardando at o arquivo liberar
  }
  do{
   b_lidos=read(arq_maildir,buffer,TAM_buffer);
   buffer[b_lidos]=0;
   for(cont1=0;cont1<b_lidos;cont1++){
    linha[cont2]=0;
    if(buffer[cont1]==10){
     if(prim_linha){
      // Primeira linha 
      strncpy(linha_quota,linha,sizeof(linha_quota));
      prim_linha=0;
     }else {
      if(cont2>3){
       temp=sscanf(linha,"%lld %lld",&tam,&num);
       if(temp==2){
        ttotal+=tam;
        ntotal+=num;
        if(ttotal<0)ttotal=0;
        if(ntotal<0)ntotal=0;
       }
      }
     }
     cont2=0;
    }else if(buffer[cont1]!=13){
     linha[cont2]=buffer[cont1];
     cont2++;
    }
   }
  }while(b_lidos==TAM_buffer);
  if(cont3<100){
   // Arquivo travado. Vamos alterar os dados dele para ficar menor
   b_lidos=sprintf(buffer,"%s\n%12lld %12lld\n",linha_quota,ttotal,ntotal);
   lseek(arq_maildir,0,0);
   write(arq_maildir,buffer,b_lidos);
   close(arq_maildir);
   snprintf(linha,sizeof(linha),"%s/%s/maildirsize",home,maildir);
   truncate(linha,b_lidos);
  }else close(arq_maildir);
  *tam_cxp=ttotal;
  *num_msgs=ntotal;
  return;
  break;
 case MAILBOX:
  // Sem suporte a MAILBOX no momento
  break;
 }
}


//---------------------------------------------------
// Reliza a conversao de um dominio alias            
// Retornos:                                         
// 0 = Nada encontrado                               
// 1 = Dominio encontrado e esta em myreg[0]         
// 2 = Erro executando comando em cmd_sql            
char conv_adomain(char *adomain){
 if(adomain_table[0]){
  snprintf(cmd_sql,TAM_cmd_sql,"SELECT %s FROM %s WHERE %s='%s'",adomain_domain_field,adomain_table,adomain_field,adomain);
  if(!mysql_query(mysql,cmd_sql)){
   myres=mysql_store_result(mysql);
   if((myreg=mysql_fetch_row(myres))!=NULL)return 1;
  }else return 2;
 }
 return 0;
}


//---------------------------------------------------
// Converte um email com dominio alias em um email   
// com seu respectivo dominio verdadeiro             
// Retornos:                                         
// 0 = Nada encontrado                               
// 1 = Email existe e esta em myreg[0] e sua senha   
//     em myreg[1]                                   
// 2 = Erro executando comando em cmd_sql            
char conv_adomain_mail(char *email){
 char *ptr_aux1;
 int ret;
 
 ptr_aux1=strchr(email,'@');
 if(!ptr_aux1)return 0;
 ptr_aux1++;
 ret=conv_adomain(ptr_aux1);
 if(ret!=1)return ret;
 ptr_aux1--;
 *ptr_aux1=0;
 snprintf(linha,TAM_buffer,"%s@%s",email,myreg[0]);
 *ptr_aux1='@';
 mysql_free_result(myres);
 snprintf(cmd_sql,TAM_cmd_sql,"SELECT %s,%s,%s FROM %s WHERE %s='%s' %s",user_login_field,user_pass_field,user_home_field,user_table,user_login_field,linha,where_clause);
 if(!mysql_query(mysql,cmd_sql)){
  myres=mysql_store_result(mysql);
  if((myreg=mysql_fetch_row(myres))!=NULL)return 1;
  return 0;
 }
 return 2;
}


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
int main(int argc,char *argv[]){
 FILE *arq_conf;
 char tentativa_cnx=0;
 //---
 char vazio=0;
 char byte=0;
 char byte2=0;
 char adomain_alias_mail[TAM_cmd+1]={0};
 char *ptr_aux=cmd;
 char *ptr_aux1;
 char *ptr_aux2;
 char *ptr_quota[MAX_ptr_quota];
 unsigned int cont_ptr_quota=0;
 unsigned int alias_cont=0;
 unsigned int b_lidos=0;
 unsigned int cont1=0;
 unsigned int cont2=0;
 long long int bd_ttotal=0;
 long long int bd_ntotal=0;
 long long int ttotal=0;
 long long int ntotal=0;
 
 setbuf(stdout,NULL);
 umask(0000);
 /* -- Lendo arquivo de configurao -- */
 if(argc<2){
  printf("!ERROR Arquivo de configuracao nao especificado\n");
  return 1;
 }
 arq_conf=fopen(argv[1],"rb");
 if(!arq_conf){
  printf("!ERROR Nao foi possivel abrir o arquivo de configuracao [%s]\n",argv[1]);
  return 1;
 }
 cont2=0;
 while(!feof(arq_conf)){
  b_lidos=fread(&buffer,1,TAM_buffer,arq_conf);
  for(cont1=0;cont1<b_lidos;cont1++){
   if(buffer[cont1]==10){
    linha[cont2]=0;
    if(!cont2)continue;
    if(linha[0]=='#'){
     cont2=0;
     continue;
    }
    if(!cmp_str(linha,"host=",5)){
     /* -- HOST -- */
     ptr=&linha[5];
     while(*ptr==' ' || *ptr==9)ptr++;
     strncpy(host,ptr,sizeof(host));
    }else if(!cmp_str(linha,"db=",3)){
     /* -- DB -- */
     ptr=&linha[3];
     while(*ptr==' ' || *ptr==9)ptr++;
     strncpy(db,ptr,sizeof(db));
    }else if(!cmp_str(linha,"user=",5)){
     /* -- USER -- */
     ptr=&linha[5];
     while(*ptr==' ' || *ptr==9)ptr++;
     strncpy(user,ptr,sizeof(user));
    }else if(!cmp_str(linha,"pass=",5)){
     /* -- PASS -- */
     ptr=&linha[5];
     while(*ptr==' ' || *ptr==9)ptr++;
     strncpy(pass,ptr,sizeof(pass));
    }else if(!cmp_str(linha,"user_table=",11)){
     /* -- USER_TABLE -- */
     ptr=&linha[11];
     while(*ptr==' ' || *ptr==9)ptr++;
     strncpy(user_table,ptr,sizeof(user_table));
    }else if(!cmp_str(linha,"user_login_field=",17)){
     /* -- USER_LOGIN_FIELD -- */
     ptr=&linha[17];
     while(*ptr==' ' || *ptr==9)ptr++;
     strncpy(user_login_field,ptr,sizeof(user_login_field));
    }else if(!cmp_str(linha,"user_pass_field=",16)){
     /* -- USER_PASS_FIELD -- */
     ptr=&linha[16];
     while(*ptr==' ' || *ptr==9)ptr++;
     strncpy(user_pass_field,ptr,sizeof(user_pass_field));
    }else if(!cmp_str(linha,"user_home_field=",16)){
     /* -- USER_HOME_FIELD -- */
     ptr=&linha[16];
     while(*ptr==' ' || *ptr==9)ptr++;
     strncpy(user_home_field,ptr,sizeof(user_home_field));
    }else if(!cmp_str(linha,"user_maildir_field=",19)){
     /* -- USER_MALDIR_FIELD -- */
     ptr=&linha[19];
     while(*ptr==' ' || *ptr==9)ptr++;
     strncpy(user_maildir_field,ptr,sizeof(user_maildir_field));
    }else if(!cmp_str(linha,"user_quota_field=",17)){
     /* -- USER_QUOTA_FIELD -- */
     ptr=&linha[17];
     while(*ptr==' ' || *ptr==9)ptr++;
     strncpy(user_quota_field,ptr,sizeof(user_quota_field));
    }else if(!cmp_str(linha,"user_dlocal_field=",18)){
     /* -- USER_DLOCAL_FIELD -- */
     ptr=&linha[18];
     while(*ptr==' ' || *ptr==9)ptr++;
     strncpy(user_dlocal_field,ptr,sizeof(user_dlocal_field));
    }else if(!cmp_str(linha,"user_pass_type=",15)){
     /* -- USER_PASS_TYPE -- */
     ptr=&linha[16];
     while(*ptr==' ' || *ptr==9)ptr++;
     strncpy(user_pass_type,ptr,sizeof(user_pass_type));
    }else if(!cmp_str(linha,"domain_table=",13)){
     /* -- DOMAIN_TABLE -- */
     ptr=&linha[13];
     while(*ptr==' ' || *ptr==9)ptr++;
     strncpy(domain_table,ptr,sizeof(domain_table));
    }else if(!cmp_str(linha,"domain_field=",13)){
     /* -- DOMAIN_FIELD -- */
     ptr=&linha[13];
     while(*ptr==' ' || *ptr==9)ptr++;
     strncpy(domain_field,ptr,sizeof(domain_field));
    }else if(!cmp_str(linha,"alias_table=",12)){
     /* -- ALIAS_TABLE -- */
     ptr=&linha[12];
     while(*ptr==' ' || *ptr==9)ptr++;
     strncpy(alias_table,ptr,sizeof(alias_table));
    }else if(!cmp_str(linha,"alias_field=",12)){
     /* -- ALIAS_FIELD -- */
     ptr=&linha[12];
     while(*ptr==' ' || *ptr==9)ptr++;
     strncpy(alias_field,ptr,sizeof(alias_field));
    }else if(!cmp_str(linha,"alias_rcpt_field=",17)){
     /* -- ALIAS_RCPT_FIELD -- */
     ptr=&linha[17];
     while(*ptr==' ' || *ptr==9)ptr++;
     strncpy(alias_rcpt_field,ptr,sizeof(alias_rcpt_field));
    }else if(!cmp_str(linha,"adomain_table=",14)){
     /* -- ADOMAIN_TABLE -- */
     ptr=&linha[14];
     while(*ptr==' ' || *ptr==9)ptr++;
     strncpy(adomain_table,ptr,sizeof(adomain_table));
    }else if(!cmp_str(linha,"adomain_field=",14)){
     /* -- ADOMAIN_FIELD -- */
     ptr=&linha[14];
     while(*ptr==' ' || *ptr==9)ptr++;
     strncpy(adomain_field,ptr,sizeof(adomain_field));
    }else if(!cmp_str(linha,"adomain_domain_field=",21)){
     /* -- ADOMAIN_DOMAIN_FIELD -- */
     ptr=&linha[21];
     while(*ptr==' ' || *ptr==9)ptr++;
     strncpy(adomain_domain_field,ptr,sizeof(adomain_field));
    }else if(!cmp_str(linha,"adomain_alias_seek=",19)){
     /* -- ADOMAIN_ALIAS_SEEK -- */
     ptr=&linha[19];
     while(*ptr==' ' || *ptr==9)ptr++;
     if(!cmp_str(ptr,"yes\0",4))adomain_alias_seek=1;
     else if(!strcmp(ptr,"1"))adomain_alias_seek=1;
     else if(!cmp_str(ptr,"on\0",3))adomain_alias_seek=1;
     else if(!cmp_str(ptr,"enable\0",7))adomain_alias_seek=1;
    }else if(!cmp_str(linha,"where_clause=",13)){
     /* -- WHERE_CLAUSE -- */
     ptr=&linha[13];
     while(*ptr==' ' || *ptr==9)ptr++;
     snprintf(where_clause,sizeof(where_clause)-1,"AND %s",ptr);
    }else if(!cmp_str(linha,"user_pass_query=",16)){
     /* -- USER_PASS_QUERY -- */
     ptr=&linha[16];
     while(*ptr==' ' || *ptr==9)ptr++;
     strncpy(user_pass_query, ptr, sizeof(user_pass_query));
    }else if(!cmp_str(linha,"reset_pass=",11)){
     /* -- reset_pass -- */
     ptr=&linha[11];
     while(*ptr==' ' || *ptr==9)ptr++;
     if(!cmp_str(ptr,"yes\0",4))reset_pass=1;
     else if(!strcmp(ptr,"1"))reset_pass=1;
     else if(!cmp_str(ptr,"on\0",3))reset_pass=1;
     else if(!cmp_str(ptr,"enable\0",7))reset_pass=1;
    }else if(!cmp_str(linha,"quota_type=",11)){
     /* -- QUOTA_TYPE -- */
     ptr=&linha[11];
     while(*ptr==' ' || *ptr==9)ptr++;
     if(!cmp_str(ptr,"maildirsize\0",12)){
      // MAILDIRSIZE
      quota_type=1;
     }else {
      printf("!ERROR quota_type invalido: [%s]\n",ptr);
      return 1;
     }
    }else {
     printf("!ERROR Opcao invalida: [%s]\n",linha);
     return 1;
    }
    cont2=0;
   }else if(buffer[cont1]!=13){
    linha[cont2]=buffer[cont1];
    cont2++;
   }
  }
 }
 
 if(!host[0] || !db[0] || !user[0] || !pass[0] || !user_table[0] || !user_login_field[0] || !user_pass_field[0] || !user_home_field[0] || !user_maildir_field[0] || !user_pass_type[0] || !user_quota_field[0] || !domain_table[0] || !domain_field[0] || !alias_table[0] || !alias_field[0] || !alias_rcpt_field[0]){
  printf("Faltam os seguintes parametros no arquivo de configuracao:\n");
  if(!host[0])printf(" host=\n");
  if(!db[0])printf(" db=\n");
  if(!user[0])printf(" user=\n");
  if(!pass[0])printf(" pass=\n");
  if(!user_table[0])printf(" user_table=\n");
  if(!user_login_field[0])printf(" user_login_field=\n");
  if(!user_pass_field[0])printf(" user_pass_field=\n");
  if(!user_home_field[0])printf(" user_home_field=\n");
  if(!user_maildir_field[0])printf(" user_maildir_field=\n");
  if(!user_quota_field[0])printf(" user_quota_field=\n");
  if(!user_pass_type[0])printf(" user_pass_type=\n");
  if(!domain_table[0])printf(" domain_table=\n");
  if(!domain_field[0])printf(" domain_field=\n");
  if(!alias_table[0])printf(" alias_table=\n");
  if(!alias_field[0])printf(" alias_field=\n");
  if(!alias_rcpt_field[0])printf(" alias_rcpt_field=\n");
  printf("\nOs seguintes parametros sao opcionais:\n");
  printf(" where_clause=\n");
  printf(" adomain_table=\n");
  printf(" adomain_field=\n");
  printf(" adomain_domain_field=\n");
  printf(" adomain_alias_seek=\n");
  printf("\n");
  return 1;
 }
 mysql = mysql_init(NULL);
 if(!mysql){
  printf("!ERROR Nao foi possivel iniciar as funes do Mysql\n\n");
  return 1;
 }
 // --- Conectando ao banco de dados ---
 mysqlt=mysql_real_connect(mysql,host,user,pass,db,0,NULL,0);
 cont1=0;
 if(mysql==mysqlt)printf("+OK SCEO_Mysql v %s Conectado\n",VERSAO);
 else printf("+OK SCEO_Mysql v %s Nao conectado\n",VERSAO);
 while((byte=fgetc(stdin))!=EOF){
  cmd[cont1]=byte;
  cont1++;
  if(cont1>=TAM_cmd){
   printf("!ERROR Comando muito grande\n");
   cont1=0;
   cmd[0]=0;
  }else {
   if(byte==10){
    cont1--;
    cmd[cont1]=0;
    tentativa_cnx=0;
    // -- Interpretando comando --
    if(!strncmp(cmd,"local ",6)){
     //---------------------
     //-- << CMD local >> --
     //---------------------
     ptr=&cmd[6];
     snprintf(cmd_sql,TAM_cmd_sql,"SELECT * FROM %s WHERE %s='%s'",domain_table,domain_field,ptr);
     CMD_local:
     if(!mysql_query(mysql,cmd_sql)){
      myres=mysql_store_result(mysql);
      if((myreg=mysql_fetch_row(myres))!=NULL)printf("+OK\n");
      else {
       // Checando se existe ALIAS DOMAIN
       mysql_free_result(myres);
       myres=NULL;
       cont2=conv_adomain(ptr);
       if(!cont2)printf("-Nao local\n");
       else if(cont2==1)printf("+OK\n");
       else printf("!ERROR Erro executando: [%s]\n",cmd_sql);
      }
      mysql_free_result(myres);
     }else {
      if(mysql_errno(mysql)==CR_SERVER_GONE_ERROR && !tentativa_cnx){
       // Sem conexao
       tentativa_cnx=1;
       mysqlt=mysql_real_connect(mysql,host,user,pass,db,0,NULL,0);
       if(mysql==mysqlt)goto CMD_local;
      }
      printf("!ERROR Erro executando: [%s]\n",cmd_sql);
     }
    }else if(!strncmp(cmd,"user ",5) || !strncmp(cmd,"home ",5)){
     //-------------------------
     //-- << CMD user/home >> --
     //-------------------------
     ptr=&cmd[5];
     if(cmd[0]=='u')snprintf(cmd_sql,TAM_cmd_sql,"SELECT * FROM %s WHERE %s='%s' %s",user_table,user_login_field,ptr,where_clause);
     else snprintf(cmd_sql,TAM_cmd_sql,"SELECT %s FROM %s WHERE %s='%s'",user_home_field,user_table,user_login_field,ptr);
     CMD_user:
     if(!mysql_query(mysql,cmd_sql)){
      myres=mysql_store_result(mysql);
      if((myreg=mysql_fetch_row(myres))!=NULL){
       if(cmd[0]=='u')printf("+OK\n");
       else printf("+OK %s\n",myreg[0]);
      }else {
       // Checando se existe ALIAS DOMAIN e seu email
       mysql_free_result(myres);
       myres=NULL;
       byte2=0;
       if(cmd[0]=='h'){
        // Vamos desativar temporariamente o where_clause
        // para nao dar problemas de consulta HOME em emails bloqueados
        byte2=*where_clause;
        *where_clause=0;
        cont2=conv_adomain_mail(ptr);
        *where_clause=byte2;
        byte2=2;
       }else cont2=conv_adomain_mail(ptr);
       if(!cont2)printf("-Email inexistente\n");
       else if(cont2==1)printf("+OK %s\n",myreg[(int)byte2]);
       else printf("!ERROR Erro executando: [%s]\n",cmd_sql);
      }
      mysql_free_result(myres);
     }else {
      if(mysql_errno(mysql)==CR_SERVER_GONE_ERROR && !tentativa_cnx){
       // Sem conexao
       tentativa_cnx=1;
       mysqlt=mysql_real_connect(mysql,host,user,pass,db,0,NULL,0);
       if(mysql==mysqlt)goto CMD_user;
      }
      printf("!ERROR Erro executando: [%s]\n",cmd_sql);
     }
    }else if(!strncmp(cmd,"userd ",6)){
     //---------------------
     //-- << CMD userd >> --
     //---------------------
     ptr=&cmd[6];
     adomain_alias_mail[0]=0;
     Nova_consulta_userd:
     if(user_dlocal_field[0])snprintf(cmd_sql,TAM_cmd_sql,"SELECT %s,%s,%s,%s,%s FROM %s WHERE %s='%s' %s",user_login_field,user_pass_field,user_home_field,user_quota_field,user_dlocal_field,user_table,user_login_field,ptr,where_clause);
     else snprintf(cmd_sql,TAM_cmd_sql,"SELECT %s,%s,%s,%s FROM %s WHERE %s='%s' %s",user_login_field,user_pass_field,user_home_field,user_quota_field,user_table,user_login_field,ptr,where_clause);
     CMD_userd:
     if(!mysql_query(mysql,cmd_sql)){
      myres=mysql_store_result(mysql);
      if((myreg=mysql_fetch_row(myres))!=NULL){
       if(user_dlocal_field[0]){
        ptr_aux1=myreg[4];
        if(!ptr_aux1)ptr_aux1=&vazio;
        else {
         // Procurando e retirando as aspas dos cantos
         if(*ptr_aux1 == '"')*ptr_aux1++;
         ptr_aux2=strchr(ptr_aux1, '"');
         if(ptr_aux2)*ptr_aux2=0;
        }
        printf("+OK user=\"%s\" pass=\"%s\" home=\"%s\" quota=\"%s\" dlocal=\"%s\"\n",myreg[0],myreg[1],myreg[2],myreg[3],ptr_aux1);
       }else printf("+OK user=\"%s\" pass=\"%s\" home=\"%s\" quota=\"%s\"\n",myreg[0],myreg[1],myreg[2],myreg[3]);
      }else {
       if(adomain_alias_mail[0])printf("-Email inexistente\n");
       else {
        // Checando se existe ALIAS DOMAIN e seu email
        mysql_free_result(myres);
        myres=NULL;
        cont2=conv_adomain_mail(ptr);
        if(!cont2)printf("-Email inexistente\n");
        else if(cont2==1){
         strncpy(adomain_alias_mail,myreg[0],sizeof(adomain_alias_mail));
         ptr=adomain_alias_mail;
         goto Nova_consulta_userd;
        }
       }
      }
      mysql_free_result(myres);
      myres=NULL;
     }else {
      if(mysql_errno(mysql)==CR_SERVER_GONE_ERROR && !tentativa_cnx){
       // Sem conexao
       tentativa_cnx=1;
       mysqlt=mysql_real_connect(mysql,host,user,pass,db,0,NULL,0);
       if(mysql==mysqlt)goto CMD_userd;
      }
      printf("!ERROR Erro executando: [%s]\n",cmd_sql);
     }
    }else if(!strncmp(cmd,"auth ",5)){
     //--------------------
     //-- << CMD auth >> --
     //--------------------
     ptr=&cmd[5];
     ptr_aux=strchr(ptr,' ');
     if(ptr_aux!=NULL){
      tam_user=ptr_aux-ptr;
      ptr_aux[0]=0;
      ptr_aux++;        // ptr_aux agora esta apontando para a senha
      if(!user_pass_query[0])snprintf(cmd_sql,TAM_cmd_sql,"SELECT %s FROM %s WHERE %s='%s' %s",user_pass_field,user_table,user_login_field,ptr,where_clause);
      else cp_str_var(cmd_sql, user_pass_query); // Query especificada
      CMD_auth:
      if(!mysql_query(mysql,cmd_sql)){
       myres=mysql_store_result(mysql);
       if((myreg=mysql_fetch_row(myres))!=NULL){
        if(!cmp_str(user_pass_type,"crypt",strlen(user_pass_type))){
         /* --- Modo de senha criptografada --- */
         if(reset_pass && !myreg[0][0]){
          // Resetando senha
          snprintf(cmd_sql,TAM_cmd_sql,"UPDATE %s SET %s='%s' WHERE %s='%s'",user_table,user_pass_field,crypt(ptr_aux,"SM"),user_login_field,ptr);
          if(!mysql_query(mysql,cmd_sql))printf("+OK\n");
          else printf("-Senha invalida\n");
         }else {
          if(myreg[0][0] && !strcmp((char *)crypt(ptr_aux,myreg[0]),myreg[0]))printf("+OK\n");
          else printf("-Senha invalida\n");
         }
        }else {
         /* --- Modo de senha texto --- */
         if(reset_pass && !myreg[0][0]){
          // Resetando senha
          snprintf(cmd_sql,TAM_cmd_sql,"UPDATE %s SET %s='%s' WHERE %s='%s'",user_table,user_pass_field,ptr_aux,user_login_field,ptr);
          if(!mysql_query(mysql,cmd_sql))printf("+OK\n");
          else printf("-Senha invalida\n");
         }else {
          if(!strcmp(ptr_aux,myreg[0]))printf("+OK\n");
          else printf("-Senha invalida\n");
         }
        }
       }else {
        // Checando se existe ALIAS DOMAIN e seu email
        mysql_free_result(myres);
        myres=NULL;
        cont2=conv_adomain_mail(ptr);
        if(!cont2)printf("-Usuario inexistente\n");
        else if(cont2==1){
         if(!cmp_str(user_pass_type,"crypt",strlen(user_pass_type))){
          /* --- Modo de senha criptografada --- */
          if(!strcmp((char *)crypt(ptr_aux,myreg[1]),myreg[1]))printf("+OK\n");
          else printf("-Senha invalida\n");
         }else {
          /* --- Modo de senha texto --- */
          if(!strcmp(ptr_aux,myreg[1]))printf("+OK\n");
          else printf("-Senha invalida\n");
         }
        }else printf("!ERROR Erro executando: [%s]\n",cmd_sql);
       }
       mysql_free_result(myres);
      }else {
       if(mysql_errno(mysql)==CR_SERVER_GONE_ERROR && !tentativa_cnx){
        // Sem conexao
        tentativa_cnx=1;
        mysqlt=mysql_real_connect(mysql,host,user,pass,db,0,NULL,0);
        if(mysql==mysqlt)goto CMD_auth;
       }
       printf("!ERROR Erro executando: [%s]\n",cmd_sql);
      }
     }else {
      printf("!ERROR Parametro invalido. Ex: auth usuario senha\n");
     }
    }else if(!strncmp(cmd,"alias ",6)){
     //---------------------
     //-- << CMD alias >> --
     //---------------------
     ptr=&cmd[6];
     ptr_aux=strchr(ptr,' ');
     if(ptr_aux!=NULL){
      *ptr_aux=0;
      ptr_aux++; 
     }else ptr_aux="0\0";
     adomain_alias_mail[0]=0;
     Nova_busca_alias:
     snprintf(cmd_sql,TAM_cmd_sql,"SELECT %s FROM %s WHERE %s='%s' LIMIT %s,%d",alias_rcpt_field,alias_table,alias_field,ptr,ptr_aux,ALIAS_LIMIT);
     alias_cont=0;
     CMD_alias:
     if(!mysql_query(mysql,cmd_sql)){
      myres=mysql_store_result(mysql);
      buffer[0]=0;
      while((myreg=mysql_fetch_row(myres))!=NULL){
       sprintf(linha,"+OK %s\n",myreg[0]);                   // Precisamos acumular os alias em uma variavel 
       strcat(buffer,linha);                                 // e envia-los ao Sceo (printf)de uma s vez    
       alias_cont++;
      }
      if(!alias_cont && *ptr!='@'){
      	// Nada encontrado. Vamos procurar por conta PEGA-TUDO
      	ptr=strchr(ptr,'@');
      	if(ptr){
      	 mysql_free_result(myres);
        myres=NULL;
      	 goto Nova_busca_alias;
      	}
      }else if(adomain_alias_seek && !alias_cont && !adomain_alias_mail[0]){
       // Vamos procurar por um alias domain e refazer as buscas
       mysql_free_result(myres);
       myres=NULL;
       *ptr=0;
       ptr++;
       cont2=conv_adomain(ptr);
       if(cont2==1){
        snprintf(adomain_alias_mail,TAM_cmd,"%s@%s",&cmd[6],myreg[0]);
        ptr=adomain_alias_mail;
        mysql_free_result(myres);
        myres=NULL;
        goto Nova_busca_alias;
       }
       else if(cont2==2){
        printf("!ERROR Erro executando: [%s]\n",cmd_sql);
        goto Prox_comando;
       }
      }
      if(alias_cont<ALIAS_LIMIT)strcat(buffer,"+OK\n");      //Caso retorne ALIAS_LIMIT resultados, no mostrar o +OK\n
      printf("%s",buffer);
      mysql_free_result(myres);
     }else {
      if(mysql_errno(mysql)==CR_SERVER_GONE_ERROR && !tentativa_cnx){
       // Sem conexao
       tentativa_cnx=1;
       mysqlt=mysql_real_connect(mysql,host,user,pass,db,0,NULL,0);
       if(mysql==mysqlt)goto CMD_alias;
      }
      printf("!ERROR Erro executando: [%s]\n",cmd_sql);
     }
    }else if(!strncmp(cmd,"quota ",6) || !strncmp(cmd,"qtest ",6)){
     //---------------------
     //-- << CMD quota >> --
     //---------------------
     ptr=&cmd[6];
     snprintf(cmd_sql,TAM_cmd_sql,"SELECT %s, %s, %s FROM %s WHERE %s='%s'",user_quota_field,user_home_field,user_maildir_field,user_table,user_login_field,ptr);
     CMD_quota:
     if(!mysql_query(mysql,cmd_sql)){
      myres=mysql_store_result(mysql);
      if((myreg=mysql_fetch_row(myres))==NULL){
       // Nao encontrado. Vamos procurar um pelo alias domain
       mysql_free_result(myres);
       myres=NULL;
       cont2=conv_adomain_mail(ptr);
       if(!cont2){
        printf("-Email inexistente\n");
        mysql_free_result(myres);
        myres=NULL;
        goto Prox_comando;
       }
       if(cont2==2){
        printf("!ERROR Erro executando: [%s]\n",cmd_sql);
        goto Prox_comando;
       }
       snprintf(cmd_sql,TAM_cmd_sql,"SELECT %s, %s, %s FROM %s WHERE %s='%s'",user_quota_field,user_home_field,user_maildir_field,user_table,user_login_field,myreg[0]);
       mysql_free_result(myres);
       myres=NULL;
       if(mysql_query(mysql,cmd_sql)){
        printf("!ERROR Erro executando: [%s]\n",cmd_sql);
        goto Prox_comando;
       }
       myres=mysql_store_result(mysql);
       myreg=mysql_fetch_row(myres);
      }
      if(myreg!=NULL){
       if(cmd[1]=='t'){
        // Testando o atual tamanho da caixa postal
        if((myreg[0][0]=='0' && !myreg[0][1]) || (!myreg[0][0]))printf("+OK Free\n");
        else {
         // Lendo as inf. retornadas pelo BD 
         cont_ptr_quota=0;
         bd_ttotal=0;
         bd_ntotal=0;
         strncpy(linha,myreg[0],sizeof(linha)-1);
         ptr_aux1=linha;
         while(*ptr_aux1==' ')ptr_aux1++;         // Tirando espacos na frente da informacao, se tiver
         ptr_quota[cont_ptr_quota]=ptr_aux1;
         while(*ptr_aux1){
         // Separando dados do campo Quota do BD 
          if(*ptr_aux1==' ')*ptr_aux1=0;
          else if(*ptr_aux1==','){
      	   *ptr_aux1=0;
      	   ptr_aux1++;
      	   while(*ptr_aux1==' ')ptr_aux1++;
       	   cont_ptr_quota++;
       	   ptr_quota[cont_ptr_quota]=ptr_aux1;
          }
          ptr_aux1++;
         }
         for(cont2=0;cont2<=cont_ptr_quota;cont2++){
          // Lendo valores
          if(strchr(ptr_quota[cont2],'S')){
           // Quota de tamanho
           if(!bd_ttotal)bd_ttotal=atoll(ptr_quota[cont2]);
          }else if(strchr(ptr_quota[cont2],'C')){
           // Quota por numero de msgs
           if(!bd_ntotal)bd_ntotal=atoll(ptr_quota[cont2]);
          }else {
           // Por numero do campo
           if(!cont2)bd_ttotal=atoll(ptr_quota[cont2]);
           else if(cont2==1)bd_ntotal=atoll(ptr_quota[cont2]);
          }
         }
         ret_quota(myreg[1],myreg[2],&ttotal,&ntotal);
         if((bd_ttotal && ttotal>=bd_ttotal) || (bd_ntotal && ntotal>=bd_ntotal))printf("+OK Exceeded\n");
         else printf("+OK Free\n");
        }
       }else printf("+OK %s\n",myreg[0]);
      }else printf("-Email inexistente\n");
      mysql_free_result(myres);
     }else {
      if(mysql_errno(mysql)==CR_SERVER_GONE_ERROR && !tentativa_cnx){
       // Sem conexao
       tentativa_cnx=1;
       mysqlt=mysql_real_connect(mysql,host,user,pass,db,0,NULL,0);
       if(mysql==mysqlt)goto CMD_quota;
      }
      printf("!ERROR Erro executando: [%s]\n",cmd_sql);
     }
    }else if(!strncmp(cmd,"cmds",4)){
     // -- CMDS --
     printf("+OK local user userd auth alias quota cmds\n");
    }else {
     // -- Comando desconhecido --
     printf("!ERROR Comando desconhecido\n");
    }
    Prox_comando:
    cont1=0;
    cmd[0]=0;
   }
  }
 }
 return 0;
}


